import { Module } from '@nestjs/common';
import { PipelineTasksService } from './pipeline-tasks.service';
import { PipelineTasksResolver } from './pipeline-tasks.resolver';
import { TypeOrmModule } from '@nestjs/typeorm';
import { PipelineTask } from './pipeline-task.entity';
import { Pipeline } from '../pipelines/pipeline.entity';
import { ReposModule } from '../repos/repos.module';
import { RedisModule } from 'nestjs-redis';
import { BullModule } from '@nestjs/bull';
import {
  PIPELINE_TASK_QUEUE,
  PIPELINE_TASK_LOG_QUEUE,
} from './pipeline-tasks.constants';

@Module({
  imports: [
    TypeOrmModule.forFeature([PipelineTask, Pipeline]),
    BullModule.registerQueue(
      {
        name: PIPELINE_TASK_QUEUE,
      },
      { name: PIPELINE_TASK_LOG_QUEUE },
    ),
    RedisModule,
    ReposModule,
  ],
  providers: [PipelineTasksService, PipelineTasksResolver],
})
export class PipelineTasksModule {}
